
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/cybergraphics.h>
#include <cybergraphx/cybergraphics.h>

struct Library *CyberGfxBase;

int main (void)

{
struct Window *win;
struct BitMap *bm;
ULONG w,h;
struct IntuiMessage *mess;
BOOL weiter;
APTR bmlock;
ULONG bpr;
UBYTE *dataptr;
UBYTE *yptr,*xptr;
ULONG x,y;
ULONG r,g,b;

CyberGfxBase = OpenLibrary ("cybergraphics.library",0);

if (CyberGfxBase == NULL)
	{
	Printf ("Dieses Programm bentigt CyberGraphics oder Picasso96 !\n");
	return (RETURN_FAIL);
	}

win = OpenWindowTags (NULL,
		WA_Left,100,
		WA_Top,100,
		WA_Width,300,
		WA_Height,200,
		WA_Title,"Test mit einer BGR-Bitmap",
		WA_Flags,WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_ACTIVATE|WFLG_NOCAREREFRESH,
		WA_IDCMP,IDCMP_CLOSEWINDOW|IDCMP_VANILLAKEY,
		TAG_END);

if (win == NULL)
	{
	CloseLibrary (CyberGfxBase);
	Printf ("Kann das Fenster nicht ffnen !\n");
	return (RETURN_FAIL);
	}

if (GetBitMapAttr(win->WScreen->RastPort.BitMap,BMA_DEPTH) <= 8)
	{
	CloseWindow (win);
	CloseLibrary (CyberGfxBase);
	Printf ("Dieses Programm luft nur auf einem High- oder Truecolor-Bildschirmmodus !\n");
	return (RETURN_ERROR);
	}

w = win->GZZWidth;		/* Gre des Fensterinhalts (ohne Rahmen) */
h = win->GZZHeight;

bm = AllocBitMap (w,h,24,BMF_MINPLANES|BMF_SPECIALFMT|SHIFT_PIXFMT(PIXFMT_BGR24),NULL);

if (bm == NULL)
	{
	CloseWindow (win);
	CloseLibrary (CyberGfxBase);
	Printf ("Nicht genug Speicher fr die Bitmap !\n");
	return (RETURN_FAIL);
	}

bmlock = LockBitMapTags (bm,
		LBMI_BASEADDRESS,&dataptr,
		LBMI_BYTESPERROW,&bpr,
		TAG_END);

if (bmlock == NULL)
	{
	FreeBitMap (bm);
	CloseWindow (win);
	CloseLibrary (CyberGfxBase);
	Printf ("Kann Bitmap nicht sperren !\n");
	return (RETURN_FAIL);
	}

yptr = dataptr;
for (y = 0; y < h; y++)
	{
	xptr = yptr;
	for (x = 0; x < w; x++)
		{
		r = (x * 255) / (w-1);
		g = (y * 255) / (h-1);
		b = (r + g) / 2;
		xptr[0] = b;
		xptr[1] = g;
		xptr[2] = r;
		xptr += 3;
		}
	yptr += bpr;
	}

UnLockBitMap (bmlock);

BltBitMapRastPort (bm,0,0,win->RPort,win->BorderLeft,win->BorderTop,w,h,0xc0);

FreeBitMap (bm);

weiter = TRUE;
do	{
	WaitPort (win->UserPort);
	while (mess = (struct IntuiMessage *) GetMsg (win->UserPort))
		{
		switch (mess->Class)
			{
		case IDCMP_VANILLAKEY:
			if (mess->Code == 0x1b) /* Esc */
				weiter = FALSE;
			break;
		case IDCMP_CLOSEWINDOW:
			weiter = FALSE;
			break;
			}
		ReplyMsg ((struct Message *) mess);
		}
	}
while (weiter);

CloseWindow (win);

CloseLibrary (CyberGfxBase);

return (RETURN_OK);
}


